/*
 * archiver.c - interface functions between ViSON and archivers.
 * ---------------------------------------------------------------------
 *   Ȃ͂̃t@CƈꏏɔЕzĂgpɏ]C
 * t@CRɁCgpCCρCЕz錠L܂Dgp
 * ɏ]Ȃꍇɂ͈؂̌L܂D
 *
 *   ڂ͎gp䗗D
 *
 *			     Copyright (C) 1993 Tomoaki `Niggle' Tada.
 * ---------------------------------------------------------------------
 */

static __common char *rcsid = "$Id: archiver.c,v 1.4 1993/10/08 00:26:41 Niggle Exp $";

/*
 * $Log: archiver.c,v $
 * Revision 1.4  1993/10/08  00:26:41  Niggle
 * 𓀎Ƀ^CX^vrg悤ɏύX
 *
 * Revision 1.3  1993/09/21  04:11:18  Niggle
 * *** empty log message ***
 *
 * Revision 1.2  1993/05/05  14:04:54  Niggle
 * VC^[tFCXɑΉ
 *
 * Revision 1.1  1993/04/09  14:59:23  Niggle
 * Initial revision
 *
 */

/* System headers */
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<mbstring.h>
#include<sys/stat.h>


/* Local headers */
#include"_sxlib.h"
#include"config.h"
#include"var.h"
#include"function.h"
#include"archiver.h"


/* Typedefs */
typedef struct
{
  LASCII exts;
  LASCII task_name;
  LASCII option;
  unsigned long task_check_string;
  unsigned long handle_check_string;
} archiver;


/* File scope functions */
static void send_command (int);
static void send_answer (int);
static void set_extract_directory (unsigned char *);
static void Exit (void);
static void extract_files (int, int *, unsigned char *, int);
static files *make_files (archive **);
static void sort_recursive (files *, int);


/* File scope variables */
static int my_archiver_taskid;
static archive **my_archive_handle;
static archiver **my_archiver;
static unsigned short command_mask;


/* Functions */
/************************************************
 *	    VXeCxg̊g		*
 ************************************************/
Boolean
SystemProc (void)
{
  switch (tsEventRec.what2)
    {
    case send_handle:
      if (tsEventRec.whom == (*my_archiver)->task_check_string)
	{
	  files F;
	  LASCII L;

	  EMEnCross ();

	  my_archiver_taskid = tsEventRec.tskid;
	  my_archive_handle = (archive **) tsEventRec.whom2;
	  F.next = make_files (my_archive_handle);
	  if (!F.next)
	    {
	      FatalError ("System_Lzh: Can't Make Files\n");
	      return t;
	    }
	  if (sort_kind)
	    {
	      sort_recursive (&F, sort_kind);
	    }

	  L.length = 0;
	  mbscpy (L.Lstr, (unsigned char *) "");
	  {			/* ^XNXg̍ŌɒǉD*/
	    TASK *cur;
	    for (cur = &MyTASK; cur != NULL; cur = cur->next)
	      {
		if (!cur->next)
		  {
		    make_task_list (&F, cur, &L, NULL);
		    break;
		  }
	      }
	  }
	  send_answer (send_keep);

	  EMDeCross ();
	  return nil;
	}
      break;
    case exited_archiver:
      if (tsEventRec.whom == (*my_archiver)->task_check_string)
	{
	  send_answer (send_keep);
	  exec_p = t;
	  extract_p = nil;

	  if (exit_p)
	    return t;
	}
      break;
    case aborted_archiver:
      if (tsEventRec.whom == (*my_archiver)->task_check_string)
	{
	  extract_p = nil;
	  ExitProc = NULL;
	  return t;
	}
      break;
    case 71:			/* EXITTSK */
      if (tsEventRec.whom == my_archiver_taskid)
	{
	  extract_p = nil;
	  ExitProc = NULL;
	  return t;
	}
      break;
    default:
      break;
    }
  return nil;
}

/************************************************
 *		A[JCőN		*
 ************************************************/
Boolean
exec_archiver (unsigned char *filename)
{
  unsigned char *exts;
  unsigned char buff[22];
  int number_of_arcs_resource;
  short **resID;

  exts = mbsrchr (mbsrchr (filename, '\\'), '.');
  if (!exts)
    {
      FatalError ("A[JCut@CɊgq܂.\n%s\n", filename);
      return t;
    }
  exts++;
  mbslwr ((unsigned char *) mbscpy (buff, exts));

  if (TSResIDList (&number_of_arcs_resource, &resID, my_resource, 'arcs') < 0)
    {
      FatalError ("TSResIDList Ɏs܂D");
      return t;
    }
  else
    {
      int i;
      for (i = 0; i < number_of_arcs_resource; i++)
	{
	  my_archiver = (archiver **) TSRscGet ('arcs', (*resID)[i]);
	  if (my_archiver)
	    {
	      if (!mbscmp ((*my_archiver)->exts.Lstr, buff))
		break;
	    }
	  my_archiver = NULL;
	}
    }
  MMHdlDispose ((handle) resID);

  if (!my_archiver)
    {
      FatalError ("gq %s ɑΉA[JCoo^Ă܂D", exts);
      return t;
    }


  ExitProc = Exit;
  ExtractProc = extract_files;

  {
    LASCII cmdLine;

    sprintf (
	      (char *) cmdLine.Lstr,
	      (char *) (*my_archiver)->option.Lstr,
	      TSGetID () & 0xffff,
	      (char *) filename
      );
    cmdLine.length = strlen ((char *)cmdLine.Lstr);
    if (TSFockB (0, 0, (char *)(*my_archiver)->task_name.Lstr, &cmdLine, 0, 0) < 0)
      {
	FatalError ("%s Nł܂D", (*my_archiver)->task_name.Lstr);
	return t;
      }
  }
  return nil;
}

/************************************************
 *		XDRG\̂		*
 ************************************************/
void
make_xdrg (XDRG * xdrg)
{
  xdrg->cel_type = 'XDRG';
  xdrg->rest_size = 12;
  xdrg->xdTaskId = my_archiver_taskid;
  xdrg->xdEvent = send_files_command;
  xdrg->whom = (*my_archiver)->task_check_string;
  xdrg->whom2 = (unsigned int) my_archive_handle;

  return;
}

/************************************************
 *		R}h		*
 ************************************************/
void
write_command (int c, int *v, unsigned char *dirName, int option)
{
  int i;
  archive_files *af;

  set_extract_directory (dirName);

  af = (*my_archive_handle)->block;	/* ł͍Ĕzu͔Ȃ */
  /* R}hGANA */
  for (i = 0; i < c; af++, i++)
    af->command &= 0x8000;

  af = (*my_archive_handle)->block;	/* ł͍Ĕzu͔Ȃ */
  for (i = 0; i < c; v++, i++)
    {
      af[*v].command = ((AC_EXTRACT | option) & command_mask);
    }

  return;
}


/* File Scope functions */
/************************************************
 *		R}h𑗂			*
 ************************************************/
static void
send_command (int command)
{
  int result = -2;

  TSMakeEvent ((*my_archiver)->task_check_string, (int) my_archive_handle, command, 0, 0, &tsEventRec);
  while (result == -2)
    {
      result = TSSendMes (my_archiver_taskid, &tsEventRec);
    }
  if (result < 0)
    FatalError (" TSSendMes Ɏs܂ ");

  return;
}

/************************************************
 *		Ԏo			*
 ************************************************/
static void
send_answer (int command)
{
  tsEventRec.what2 = command;
  TSAnswer (&tsEventRec);
}

/************************************************
 *		𓀐̎w			*
 ************************************************/
static void
set_extract_directory (unsigned char *dirName)
{
  int result = -2;

  TSMakeEvent ((*my_archiver)->task_check_string, (int) dirName, set_directory, 0, 0, &tsEventRec);
  while (result == -2)
    {
      result = TSSendMes (my_archiver_taskid, &tsEventRec);
    }
  if (result < 0)
    FatalError ("SetExtractDirectory: %sƂ̌MɎs\n", (*my_archiver)->task_name);
  return;
}

/************************************************
 *		t@C			*
 ************************************************/
static void
extract_files (int c, int *v, unsigned char *dirName, int option)
{

  write_command (c, v, dirName, option);
  set_extract_directory (dirName);
  send_command (send_files_command);
  if (!(option & AE_FAST))
    extract_p = t;
  return;
}

/****************************************
 *	files \̂쐬		*
 ****************************************/
static files *
make_files (archive ** archive_handle)
{
  files *cur, *last;
  files First;
  int i;
  unsigned char *FileNamePtr;
  archive_files *af;

  if ((*archive_handle)->header != (*my_archiver)->handle_check_string)
    return NULL;

  command_mask = (*archive_handle)->command_mask;

  MMHdlLock ((handle) archive_handle);
  MMHdlLock ((handle) (*archive_handle)->filename);
  FileNamePtr = *(*archive_handle)->filename;

  last = &First;
  af = (*archive_handle)->block;
  for (i = 0; i < (*archive_handle)->number_of_files; af++, i++)
    {
      cur = last->next = malloc (sizeof (files));
      if (!cur)
	{
	  FatalError ("MakeFiles_Lzh: Memory Exhaust.\n");
	  return NULL;
	}

      cur->attribute = _mode2unix (af->attribute);
      cur->fileName[0] = '\0';

      mbscpy (cur->dirName, &FileNamePtr[af->filename_offset]);
      {
	unsigned char *slash;

	_toslash (cur->dirName);
	if (*cur->dirName == '/')
	  mbscpy (cur->dirName, cur->dirName + 1);

	slash = mbsrchr (cur->dirName, '/');
	if (slash)
	  {
	    if (*(slash + 1))
	      {
		mbscpy (cur->fileName, slash + 1);
		*(slash + 1) = '\0';
	      }
	    else
	      {
		cur->attribute &= ~S_IFREG;
		cur->attribute |= S_IFDIR | S_IEXEC;
	      }
	  }
	else
	  {
	    mbscpy (cur->fileName, cur->dirName);
	    *cur->dirName = '\0';
	  }
      }
      cur->time = (af->date << 16) + af->time;
      cur->packedSize = 0;
      cur->origSize = af->file_size;
      cur->dir = NULL;

      cur->Num = i;
      cur->next = NULL;
      last = cur;
    }
  MMHdlUnlock ((handle) (*archive_handle)->filename);
  MMHdlUnlock ((handle) archive_handle);

  if (make_directory_list (&First))
    {
      FatalError ("make_directory_list Ɏs܂D\n");
      return NULL;
    }

  return First.next;
}

/************************************************
 *		I̊g			*
 ************************************************/
static void
Exit (void)
{
  send_command (send_exit);
  return;
}


/************************************************
 *	ċAIɃ\[g			*
 ************************************************/
static void
sort_recursive (files * F, int kind)
{
  files *cur;
  int i = 0;

  for (cur = F->next; cur != NULL; cur = cur->next)
    i++;

  sort_files (F, i, kind);

  for (cur = F->next; cur != NULL; cur = cur->next)
    if (cur->dir)
      {
	files D;

	D.next = cur->dir;
	sort_recursive (&D, kind);

	cur->dir = D.next;
      }
  return;
}
