/*
 * files.c - functions for files structure.
 * ---------------------------------------------------------------------
 *   Ȃ͂̃t@CƈꏏɔЕzĂgpɏ]C
 * t@CRɁCgpCCρCЕz錠L܂Dgp
 * ɏ]Ȃꍇɂ͈؂̌L܂D
 *
 *   ڂ͎gp䗗D
 *
 *			     Copyright (C) 1993 Tomoaki `Niggle' Tada.
 * ---------------------------------------------------------------------
 */

static __common char *rcsid = "$Id: files.c,v 1.5 1993/09/21 04:11:18 Niggle Exp $";

/*
 * $Log: files.c,v $
 * Revision 1.5  1993/09/21  04:11:18  Niggle
 * *** empty log message ***
 *
 * Revision 1.4  1993/05/04  13:13:38  Niggle
 * re-format only
 *
 * Revision 1.3  1993/04/29  03:10:12  Niggle
 * re-format only
 *
 * Revision 1.2  1993/04/09  14:35:11  Niggle
 * \[g̒ǉ
 *
 * Revision 1.1  1993/03/29  00:31:42  Niggle
 * Initial revision
 *
 */

/* System headers */
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<mbstring.h>
#include<limits.h>
#include<sys/stat.h>


/* Local headers */
#include"_sxlib.h"
#include"var.h"
#include"function.h"


/* File scope functions */
static int move_to_directory (files *, files *, unsigned char *);
static int count_directory_files (files *);
static files *search_directory (files *, unsigned char *);
static unsigned char *get_root (unsigned char *, unsigned char *);
static Boolean make_directory_and_move (files *);
static void sort_by_str (sArray *, int);
static void sort_by_var (sArray *, int);


/* Functions */
/********************************************************
 *	fBNgXg(ċAL)		*
 ********************************************************/
Boolean
make_directory_list (files * F)
{
  files *cur;

  /*	dir ̃t@C𐔂D	*/
  while (count_directory_files (F) > 0)
    make_directory_and_move (F);

  /*	dir TĊKw	*/
  for (cur = F->next; cur != NULL; cur = cur->next)
    {
      if (cur->dir)
	{
	  files temp;
	  temp.next = cur->dir;
	  make_directory_list (&temp);
	  cur->dir = temp.next;
	}
    }
  return nil;
}

/********************************************************
 *	T->files  iNum ɑΉ files * ԂD	*
 ********************************************************/
files *
search_files (files * F, int iNum)
{
  files *cur;

  for (cur = F->next; cur != NULL; cur = cur->next)
    if (cur->IsRecNum == iNum)
      return cur;

  return NULL;
}

/************************************************
 *	files list  free 			*
 ************************************************/
void
dispose_files (files * F)
{
  files *cur, *next;

  for (cur = F->next; cur != NULL; cur = next)
    {
      next = cur->next;
      free (cur);
    }
  return;
}

/************************************************
 * F.next  max files kind \[g	*
 ************************************************/
void
sort_files (files * F, int max, int kind)
{
  files *cur;
  sArray *sfirst;
  int i = 0;

  sfirst = calloc (max, sizeof (sArray));
  if (!sfirst)
    {
      FatalError (" sort p̃mۂł܂łD\n");
      return;
    }

  switch (kind)
    {
    case 1:
      /* :
	   fBNg擪֎Ă
	   st@CĂ
	   ̑̃t@C(O)  */
      {
	int scur;
	int dir_end;

	for (cur = F->next; cur != NULL; cur = cur->next)
	  {
	    sfirst[i].file = cur;
	    sfirst[i].var = (int) cur->fileName;
	    i++;
	  }

	/* fBNg擪ɏW߂ */
	scur = 0;
	for (i = 0; i < max; i++)
	  {
	    if (!((char *) sfirst[i].var)[0])
	      {
		sArray tmp;

		sfirst[i].var = (int) sfirst[i].file->dirName;
		tmp = sfirst[i];
		sfirst[i] = sfirst[scur];
		sfirst[scur] = tmp;
		scur++;
	      }
	  }
	sort_by_str (sfirst, scur);
	dir_end = scur;

	/* x file ߂ */
	for (i = scur; i < max; i++)
	  {
	    unsigned char *str;

	    str = (unsigned char *) sfirst[i].var;
	    str += strlen ((char *) str) - 2;
	    if (!mbscmp (str, (unsigned char *) ".x") || !mbscmp (str, (unsigned char *) ".X"))
	      {
		sArray tmp;

		tmp = sfirst[i];
		sfirst[i] = sfirst[scur];
		sfirst[scur] = tmp;
		scur++;
	      }
	  }
	sort_by_str (&sfirst[dir_end], scur - dir_end);
	sort_by_str (&sfirst[scur], max - scur);

      }
      break;
    case 2:
      /* O */
      for (cur = F->next; cur != NULL; i++, cur = cur->next)
	{
	  if (cur->fileName[0])
	    sfirst[i].var = (int) cur->fileName;
	  else
	    sfirst[i].var = (int) cur->dirName;
	  sfirst[i].file = cur;
	}
      sort_by_str (sfirst, max);
      break;
    case 3:
      /* gq */
      /* 肠Ŝ𖼑OŃ\[g */
      for (cur = F->next; cur != NULL; i++, cur = cur->next)
	{
	  if (cur->fileName[0])
	    sfirst[i].var = (int) cur->fileName;
	  else
	    sfirst[i].var = (int) cur->dirName;
	  sfirst[i].file = cur;
	}
      sort_by_str (sfirst, max);

      /* gqʂŃ\[g */
      for (i = 0; i < max; i++)
	{
	  unsigned char *str;
	  unsigned char buff[28];

	  str = mbsrchr ((unsigned char *) sfirst[i].var, '.');
	  if (str)
	    str++;
	  else
	    str = (unsigned char *) sfirst[i].var + strlen ((char *)sfirst[i].var);

	  /* \[g艻 */
	  mbscat (str, (unsigned char *) ".");
	  sprintf ((char *) buff, ".%4.4x", i);
	  mbscat (str, buff);
	  sfirst[i].var = (int) str;
	}
      sort_by_str (sfirst, max);

      /* S~ */
      for (i = 0; i < max; i++)
	*(mbschr ((unsigned char *) sfirst[i].var, '.')) = '\0';
      break;
    case 4:
      /* t */
      for (cur = F->next; cur != NULL; cur = cur->next)
	{
	  sfirst[i].var = cur->time;
	  sfirst[i].file = cur;
	  i++;
	}

      sort_by_var (sfirst, max);
      break;
    case 5:
      /* TCY */
      for (cur = F->next; cur != NULL; i++, cur = cur->next)
	{
	  sfirst[i].var = cur->origSize;
	  sfirst[i].file = cur;
	}
      sort_by_var (sfirst, max);
      break;
    default:
      for (cur = F->next; cur != NULL; i++, cur = cur->next)
	{
	  sfirst[i].file = cur;
	}
      break;
    }

  cur = F;
  for (i = 0; i < max; i++)
    cur = cur->next = sfirst[i].file;
  cur->next = NULL;

  free (sfirst);
  return;
}


/* File scope functions */
/********************************************************
 *	F ȍ~ dir Ŏn܂fBNgɊ܂܂	*
 *	̂D ֒ǉDǉt@CԂ	*
 ********************************************************/
static int
move_to_directory (files * F, files * D, unsigned char *dir)
{
  int Num = 0;			/* ړt@C */
  files temp;			/* Ȅp */
  files *dst;
  files *cur, *last;
  unsigned char buf[PATH_MAX + 1];

  temp.dir = temp.next = NULL;
  dst = &temp;

  mbsupr (mbscpy (buf, dir));
  last = F;
  for (cur = F->next; cur != NULL; cur = cur->next)
    {
      if (*cur->dirName && cur != D)
	{
	  unsigned char buf2[PATH_MAX + 1];

	  mbsupr (get_root (buf2, cur->dirName));
	  if (!mbscmp (buf, buf2))
	    {
	      unsigned char *sub = mbschr (cur->dirName, '/');

	      if (!sub)
	        *cur->dirName = '\0';
	      else
		mbscpy (cur->dirName, sub + 1);

	      dst = dst->next = cur;
	      last->next = cur->next;
	      cur = last;
	      Num++;
	    }
	}
      last = cur;
    }
  dst->next = NULL;
  D->dir = temp.next;
  return Num;
}

/********************************************************
 *	fBNgfilesCړ		*
 ********************************************************/
static Boolean
make_directory_and_move (files * F)
{
  files *cur;
  files *dir;

  for (cur = F->next; cur != NULL; cur = cur->next)
    {
      unsigned char *dirName = cur->dirName;

      if (*dirName)
	{
	  if (*cur->fileName || (mbschr (dirName, '/') != mbsrchr (dirName, '/')))
	    {
	      unsigned char buff[PATH_MAX + 1];

	      dir = search_directory (F, get_root (buff, dirName));
	      if (!dir)
	        {
		  dir = malloc (sizeof (files));
		  if (!dir)
		    {
		      FatalError ("make_directory_and_move: Memory Exhaust.  \n");
		      return t;
		    }
		  dir->fileName[0] = '\0';
		  get_root (dir->dirName, dirName);
		  dir->Num = -1;
		  dir->packedSize = 0;
		  dir->origSize = 0;
		  dir->time = 0;
		  dir->attribute = S_IFDIR | S_IEXEC | S_IWRITE | S_IREAD;
		  dir->next = F->next;
		  F->next = dir;
		  dir->dir = NULL;
	        }
	      move_to_directory (F, dir, buff);
	      break;
	    }
	}
    }
  return nil;
}

/********************************************************
 *	F fBNg̃t@C𐔂	*
 ********************************************************/
static int
count_directory_files (files * F)
{
  files *cur;
  int i = 0;

  for (cur = F->next; cur != NULL; cur = cur->next)
    {
      if (*cur->dirName)
	{
	  if (*cur->fileName)
	    {
	      /* ʏ̃t@C */
	      i++;
	    }
	  else
	    {
	      /* TufBNg邩ǂ */
	      if (mbschr (cur->dirName, '/') != mbsrchr (cur->dirName, '/'))
		{
		  i++;
	        }
	    }
	}
    }
  return i;
}

/********************************************************
 *	F  dir T dir ւ files * Ԃ	*
 ********************************************************/
static files *
search_directory (files * F, unsigned char *dir)
{
  files *cur;
  unsigned char buf1[PATH_MAX + 1], buf2[PATH_MAX + 1];

  mbsupr (mbscpy (buf1, dir));
  for (cur = F->next; cur != NULL; cur = cur->next)
    {
      mbsupr (mbscpy (buf2, cur->dirName));
      if (!mbscmp (buf1, buf2))
	{
	  if (!*cur->fileName)
	    return cur;
	}
    }
  return NULL;
}

/************************************************
 *	pX̐擪𓾂			*
 ************************************************/
static unsigned char *
get_root (unsigned char *dst, unsigned char *src)
{
  unsigned char *pos;

  mbscpy (dst, src);
  pos = mbschr (dst, '/');
  if (pos)
    *(pos + 1) = '\0';

  return dst;
}

/************************************************
 *	ɂ\[g			*
 ************************************************/
static void
sort_by_str (sArray * array, int max)
{
  int h;
  int i, j;
  sArray tmp;

  /* $ h_n = 3 h_{n-1} + 1 $ in ``The Art of Conmputer Programming'' by Knuth */
  for (h = 1; h < max / 9; h = h * 3 + 1)
    ;				/* nop */

  for (; h > 0; h /= 3)
    {
      for (i = h; i < max; i++)
	{
	  j = i;
	  while (j >= h && mbscmp ((unsigned char *) array[j - h].var, (unsigned char *) array[j].var) > 0)
	    {
	      tmp = array[j];
	      array[j] = array[j - h];
	      array[j - h] = tmp;
	      j -= h;
	    }
	}
    }

  return;
}

/************************************************
 *	lɂ\[g			*
 ************************************************/
static void
sort_by_var (sArray * array, int max)
{
  int h;
  int i, j;
  sArray tmp;

  /* $ h_n = 3 h_{n-1} + 1 $ in ``The Art of Conmputer Programming'' by Knuth */
  for (h = 1; h < max / 9; h = h * 3 + 1)
    ;				/* nop */

  for (; h > 0; h /= 3)
    {
      for (i = h; i < max; i++)
	{
	  j = i;
	  while (j >= h && array[j - h].var < array[j].var)
	    {
	      tmp = array[j];
	      array[j] = array[j - h];
	      array[j - h] = tmp;
	      j -= h;
	    }
	}
    }

  return;
}
