/*
 * misc.c - misc functions for ViSON.
 * ---------------------------------------------------------------------
 *   Ȃ͂̃t@CƈꏏɔЕzĂgpɏ]C
 * t@CRɁCgpCCρCЕz錠L܂Dgp
 * ɏ]Ȃꍇɂ͈؂̌L܂D
 *
 *   ڂ͎gp䗗D
 *
 *			     Copyright (C) 1993 Tomoaki `Niggle' Tada.
 * ---------------------------------------------------------------------
 */

static __common char *rcsid = "$Id: misc.c,v 1.4 1993/09/21 04:11:18 Niggle Exp $";

/*
 *$Log: misc.c,v $
 * Revision 1.4  1993/09/21  04:11:18  Niggle
 * *** empty log message ***
 *
 * Revision 1.3  1993/05/05  14:08:18  Niggle
 * re-format only
 *
 * Revision 1.2  1993/04/12  12:23:24  Niggle
 * 𓀐̕ύX̕s菜
 *
 * Revision 1.1  1993/04/09  15:09:38  Niggle
 * Initial revision
 *
 */


/* System headers */
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<mbstring.h>
#include<stdarg.h>
#include<unistd.h>
#include<sys/stat.h>
#include<dirent.h>
#include<ctype.h>
#include<alloca.h>
#include<limits.h>


/* Local headers */
#include	"_sxlib.h"
#include	"config.h"
#include	"var.h"
#include	"function.h"


/* File scope functions */
static void set_value (dialog *, int, int);
static int get_value (dialog *, int);
static void set_current_value (dialog *);
static void get_current_value (dialog *);
static int dialog_proc (dialog *, event *);
static Boolean check_match_files (unsigned char *, TASK *);
static Boolean match (unsigned char *, unsigned char *);


/* Functions */
/************************************************
 *	G[bZ[W̕\			*
 ************************************************/
void
FatalError (char *msg,...)
{
  char buf[PATH_MAX + 1];
  va_list args;

  va_start (args, msg);
  vsprintf (buf, msg, args);
  TSErrDialogN (1, buf);
  va_end (args);
  return;
}

/************************************************
 *		XbVɕϊ		*
 ************************************************/
unsigned char *
_toslash (unsigned char *buf)
{
  unsigned char *p;
  unsigned char *bslash;

  p = buf;
  while ((bslash = mbschr (p, '\\')))
    {
      *bslash = '/';
      p = bslash + 1;
    }

  return buf;
}

/************************************************
 *	    obNXbVɕϊ		*
 ************************************************/
unsigned char *
_tobslash (unsigned char *buf)
{
  unsigned char *p;
  unsigned char *slash;

  p = buf;
  while ((slash = mbschr (p, '/')))
    {
      *slash = '\\';
      p = slash + 1;
    }

  return buf;
}

/************************************************
 *	t@CDfBNg폜		*
 ************************************************/
Boolean
Remove (const unsigned char *filename)
{
  struct stat stbuf;
  unsigned char file[PATH_MAX + 1];

  _toslash (mbscpy (file, filename));
  if (stat ((char *) file, &stbuf) < 0)
    return t;

  if (S_ISDIR (stbuf.st_mode))
    {
      DIR *dfd;
      struct dirent *dp;

      dfd = opendir ((char *) file);
      if (dfd == NULL)
        return t;


      while ((dp = readdir (dfd)) != NULL)
	{
	  if (!mbscmp ((unsigned char *) dp->d_name, (unsigned char *) ".")
	  || !mbscmp ((unsigned char *) dp->d_name, (unsigned char *) ".."))
	    {
	      /* eC܂̓Jg */
	      /* skip */
	      continue;
	    }
	  else
	    {
	      /* ʏ̃t@CCfBNg */
	      unsigned char *buff;

	      buff = alloca (strlen ((char *) file) + strlen (dp->d_name) + 1);
	      mbscpy (buff, file);
	      mbscat (buff, (unsigned char *) "\\");
	      mbscat (buff, (unsigned char *) dp->d_name);
	      Remove (buff);
	    }
	}

      closedir (dfd);
      rmdir ((char *) file);
    }
  else
    {
      remove ((char *) file);
    }
  return nil;
}

/************************************************
 *	t@C 18+3 ɕϊ		*
 ************************************************/
Boolean
get_filename (unsigned char *dst, unsigned char *src)
{
  int extlen, len;
  unsigned char *dot;

  len = strlen ((char *) src);
  dot = mbsrchr (src, '.');

  /* ̈NA */
  memset (dst, ' ', 21);

  if (!dot)
    /* gqȂ */
    memcpy (dst, src, len);
  else
    {
      if (dot == src)
	/* .* ͊gqł͂Ȃ */
	memcpy (dst, src, len);
      else
	{
	  extlen = strlen ((char *) dot) - 1;
	  if (extlen <= 3)
	    {
	      /* gqL */
	      memcpy (dst, src, len - (extlen + 1));
	      memcpy (&dst[18], dot + 1, extlen);
	    }
	  else
	    /* Sȏ͊gqł͂Ȃ */
	    memcpy (dst, src, len);
	}
    }
  return nil;
}

/************************************************
 *	t@C 18+3 ϊ		*
 ************************************************/
Boolean
put_filename (unsigned char *dst, unsigned char *src)
{
  unsigned char *p;

  bzero (dst, 22);
  memcpy (dst, src, 18);
  p = mbschr (dst, ' ');
  if (!p)
    p = dst + 18;

  if (src[18] != ' ')
    {
      *p++ = '.';
      memcpy (p, &src[18], 3);
      p = mbschr (p, ' ');
      if (p)
	*p = '\0';
    }

  return nil;
}

/****************************************
 *		𓀐ύX		*
 ****************************************/
Boolean
get_extract_directory ()
{
  dialog *dialogPtr;
  int result;
  rect shadow_rect = (rect)
  {20, 40, 180, 52};

  dialogPtr = TSReferDM (129, 0, (window *) - 1);
  if (!dialogPtr)
    {
      FatalError ("dialog  open ł܂\n");
      return nil;
    }

  {
    short itemType;
    int itemHdl;
    rect r;
    LASCII L;

    mbscpy (L.Lstr, DstDirName);
    L.length = strlen ((char *) L.Lstr);

    if (DIGet (dialogPtr, 3, &itemType, &itemHdl, &r) >= 0)
      {
	DITSet (itemType, itemHdl, &L);
	DITSelect (dialogPtr, 3, 0, 0);
      }
  }

  /* _CAOJgɂ */
  GMSetGraph (&dialogPtr->dWindow.wGraph);
  GMAPage (3);
  GMForeColor (G_BLACK);
  GMBackColor (G_WHITE);
  GMPenMode (G_PSET);
  /* eLXghׂ */
  GMShadowRect (&shadow_rect);
  GMBackColor (G_LGRAY);

  GMFontMode (G_PSET);
  GMFontFace (0);
  GMFontKind (G_ROM12);

  GMShadowStrZ ("𓀐w", 82 * 0x10000 + 3);

  GMBackColor (G_WHITE);

  DMDraw (dialogPtr);

  result = 3;
  while (result > 2)
    result = DMControl (dialog_proc);

  if (result == 1)
    {
      short itemType;
      int itemHdl;
      rect r;
      LASCII L;
      DIR *dfd;
      unsigned char *p;

      if (DIGet (dialogPtr, 3, &itemType, &itemHdl, &r) >= 0)
	{
	  DITGet (itemType, itemHdl, &L);
	}

      L.Lstr[L.length] = '\0';
      p = mbschr (L.Lstr, ' ');
      if (p)
	*p = '\0';

      if (L.Lstr[L.length - 1] == '\\')
	{
	  L.Lstr[L.length - 1] = '\0';
	  L.length--;
	}

      dfd = opendir ((char *) L.Lstr);
      if (dfd)
	{
	  closedir (dfd);
	  mbscpy (DstDirName, L.Lstr);
	}
      else
	{
	  FatalError ("%s ݂͑ȂfBNgłD", L.Lstr);
	}
    }
  DMDispose (dialogPtr);

  return nil;
}

/********************************************************
 *	ChJ[hp̃_CAOJ		*
 ********************************************************/
Boolean
get_wild_card (TASK * T)
{
  dialog *dialogPtr;
  int result;
  rect shadow_rect = (rect)
  {20, 40, 180, 52};

  dialogPtr = TSReferDM (128, 0, (window *) - 1);
  if (!dialogPtr)
    {
      FatalError ("dialog  open ł܂\n");
      return nil;
    }

  {
    short itemType;
    int itemHdl;
    rect r;

    if (DIGet (dialogPtr, 5, &itemType, &itemHdl, &r) >= 0)
      {
	DITSet (itemType, itemHdl, &wild);
	DITSelect (dialogPtr, 5, 0, 0);
      }
  }

  /* _CAOJgɂ */
  GMSetGraph (&dialogPtr->dWindow.wGraph);
  GMAPage (3);
  GMForeColor (G_BLACK);
  GMBackColor (G_WHITE);
  GMPenMode (G_PSET);
  /* eLXghׂ */
  GMShadowRect (&shadow_rect);
  GMBackColor (G_LGRAY);

  GMFontMode (G_PSET);
  GMFontFace (0);
  GMFontKind (G_ROM12);

  GMShadowStrZ ("ChJ[h", 58 * 0x10000 + 3);
  GMShadowStrZ ("fBNg", 40 * 0x10000 + 60);
  GMShadowStrZ ("t@C", 40 * 0x10000 + 80);

  GMBackColor (G_WHITE);

  DMDraw (dialogPtr);

  set_current_value (dialogPtr);
  result = 3;
  for (;;)
    {
      result = DMControl (dialog_proc);
      if (result > 2 && result < 5)
	{
	  if (get_value (dialogPtr, result))
	    set_value (dialogPtr, result, 0);
	  else
	    set_value (dialogPtr, result, 1);
	}
      else if (result < 3)
	break;
    }

  if (result == 2)
    {
      DMDispose (dialogPtr);
      return nil;
    }

  get_current_value (dialogPtr);

  {
    short itemType;
    int itemHdl;
    rect r;

    if (DIGet (dialogPtr, 5, &itemType, &itemHdl, &r) >= 0)
      {
	DITGet (itemType, itemHdl, &wild);
      }
    DMDispose (dialogPtr);
  }

  wild.Lstr[wild.length] = '\0';
  if (T)
    {
      GMSetGraph (&T->winPtr->wGraph);
      check_match_files (wild.Lstr, T);
    }
  else
    {
      TASK *cur;
      for (cur = MyTASK.next; cur != NULL; cur = cur->next)
	{
	  GMSetGraph (&cur->winPtr->wGraph);
	  check_match_files (wild.Lstr, cur);
	}
    }

  return nil;
}


/* File scope functions */
/************************************************
 *						*
 ************************************************/
static Boolean
check_match_files (unsigned char *p, TASK * T)
{
  files *cur;
  unsigned char filename[PATH_MAX + 1];
  unsigned char *s;

  mbscpy (filename, p);
  s = mbstok (filename, (unsigned char *) " \t");
  if (!s)
    return nil;

  do
    {
      for (cur = T->files.next; cur != NULL; cur = cur->next)
	{
	  if (!directory_p)
	    if (S_ISDIR (cur->attribute))
	      continue;

	  if (!file_p)
	    if (!S_ISDIR (cur->attribute))
	      continue;

	  if (match (cur->fileName, s))
	    SetisSelFlag (T, cur->IsRecNum, cur->IsRecNum + 1, 1);
	}
    }
  while ((s = mbstok (NULL, (unsigned char *) " \t")));

  return nil;
}

/************************************************
 *	command.x CNȃ[hJ[h	*
 ************************************************/
static Boolean
match (unsigned char *s, unsigned char *p)
{
  for (;;)
    switch (*p)
      {
      case '?':		/* Cӂ̈ꕶ */
	if (*s == '\0')
	  return nil;
	else if (*s == '.')	/* dot ɂ̓}b`Ȃ */
	  return nil;
	++s;
	++p;
	break;

      case '\0':		/* EOS */
	return (*s++ == '\0');

      case '*':		/* Cӂ̕ */
	for (;;)
	  {
	    while (*++p == '*')
	      {
		/* nop */
	      }

	    if (*p != '?')
	      break;
	    ++p;
	    if (*s == '\0')
	      return nil;
	    else if (*s == '.')	/* dot ɂ̓}b`Ȃ */
	      return nil;
	    s++;
	    break;
	  }
	do
	  {
	    if (*s == '.')
	      break;
	    if (match (s, p))
	      return t;
	  }
	while (*s++);

	if (*s == '.')
	  break;

	return nil;
	break;

      case '\\':		/* NI[g */
	++p;
      default:			/* ʂ̃LN^ */
	if (*s++ != *p++)
	  return nil;
	break;
      }
}

/********************************************************
 *	_CAOACeɒlݒ			*
 ********************************************************/
static void
set_value (dialog * dlgPtr, int item, int value)
{
  rect itemRect;
  control **itemHdl;
  short itemType;

  DIGet (dlgPtr, item, &itemType, (int *) &itemHdl, &itemRect);
  CMValueSet (itemHdl, value);
}

/********************************************************
 *	_CAOACe̒l𓾂			*
 ********************************************************/
static int
get_value (dialog * dlgPtr, int item)
{
  rect itemRect;
  control **itemHdl;
  short itemType;

  DIGet (dlgPtr, item, &itemType, (int *) &itemHdl, &itemRect);
  return CMValueGet (itemHdl);
}

/********************************************************
 *		ݒn̐ݒ				*
 ********************************************************/
static void
set_current_value (dialog * dlgPtr)
{
  int value;

  if (directory_p)
    value = 1;
  else
    value = 0;
  set_value (dlgPtr, 3, value);

  if (file_p)
    value = 1;
  else
    value = 0;
  set_value (dlgPtr, 4, value);

  return;
}

/********************************************************
 *		ACe̒l𓾂			*
 ********************************************************/
static void
get_current_value (dialog * dlgPtr)
{
  if (get_value (dlgPtr, 3))
    directory_p = t;
  else
    directory_p = nil;

  if (get_value (dlgPtr, 4))
    file_p = t;
  else
    file_p = nil;

  return;
}

/********************************************************
 *		_CAÕtB^֐		*
 ********************************************************/
static int
dialog_proc (dialog * dlgPtr, event * event_rec)
{

  switch (event_rec->eWhat)
    {
    case E_KEYDOWN:
      if ((event_rec->eWhom & 0xffff) == 0x000d)
	return 1;
      else if ((event_rec->eWhom & 0xffff) == 0x001b)
	return 2;
      break;
    case E_IDLE:		/* AChCxgȂ̃Cxg */
    default:
      TMIdle (dlgPtr->dText);
      break;
    }
  return 0;
}
