/*
 * scrollbar.c for ViSON.
 * ---------------------------------------------------------------------
 *   Ȃ͂̃t@CƈꏏɔЕzĂgpɏ]C
 * t@CRɁCgpCCρCЕz錠L܂Dgp
 * ɏ]Ȃꍇɂ͈؂̌L܂D
 *
 *   ڂ͎gp䗗D
 *
 *			     Copyright (C) 1993 Tomoaki `Niggle' Tada.
 * ---------------------------------------------------------------------
 */

static __common char *rcsid = "$Id: scrollbar.c,v 1.5 1993/09/21 04:11:18 Niggle Exp $";

/*
 *$Log: scrollbar.c,v $
 * Revision 1.5  1993/09/21  04:11:18  Niggle
 * *** empty log message ***
 *
 * Revision 1.4  1993/05/04  13:19:40  Niggle
 * re-format only
 *
 * Revision 1.3  1993/04/23  21:18:50  Niggle
 * rcsid̈ύX
 *
 * Revision 1.2  1993/04/09  11:53:29  Niggle
 * ኱̍
 *
 * Revision 1.1  1993/03/29  02:14:20  Niggle
 * Initial revision
 *
 */

/* System headers */
#include<stdlib.h>


/* Local headers */
#include"_sxlib.h"
#include"config.h"
#include"var.h"
#include"function.h"


/* Macros */
#define POINT_T(a) ((a.x << 16) + a.y)


/* File scope functions */
static Boolean set_scrollbar_value (TASK *);
static void set_scrollbar_rect (TASK *);


/* Functions */
/************************************************
 *	XN[o[̃I[v		*
 ************************************************/
Boolean
open_scrollbar (TASK * T)
{
  set_scrollbar_rect (T);

  T->scBVHdl = CMOpen (T->winPtr, &T->scBVRect, (LASCII *) "", 0, 0, 0, 0, (SCBV_ID << 4), 0);
  if (!T->scBVHdl)
    return t;

  T->scBHHdl = CMOpen (T->winPtr, &T->scBHRect, (LASCII *) "", 0, 0, 0, 0, (SCBH_ID << 4), 0);
  if (!T->scBHHdl)
    return t;

  set_scrollbar_value (T);
  return nil;
}

/************************************************
 *	XN[o[p			*
 ************************************************/
Boolean
dispose_scrollbar (TASK * T)
{
  if (T->scBVHdl)
    CMDispose (T->scBVHdl);
  if (T->scBHHdl)
    CMDispose (T->scBHHdl);
  return nil;
}

/************************************************
 *	XN[o[			*
 ************************************************/
void
hide_scrollbar (TASK * T)
{
  CMHide (T->scBVHdl);
  CMHide (T->scBHHdl);

  return;
}

/************************************************
 *	XN[o[\			*
 ************************************************/
void
show_scrollbar (TASK * T)
{
  CMShow (T->scBVHdl);
  CMShow (T->scBHHdl);

  return;
}

/************************************************
 *	XN[o[			*
 ************************************************/
void
draw_scrollbar (TASK * T)
{
  set_scrollbar_value (T);
  show_scrollbar (T);

  return;
}

/************************************************
 *	XN[o[̈ʒuČvZ		*
 ************************************************/
void
re_calc_scrollbar (TASK * T)
{
  if (!T->scBVHdl && !T->scBHHdl)
    return;

  GMSetGraph (&T->winPtr->wGraph);
  set_scrollbar_rect (T);
  set_scrollbar_value (T);
  hide_scrollbar (T);

  {
    rect VRect, HRect;
    control **VHdl, **HHdl;
    point size;

    VRect = T->scBVRect;
    HRect = T->scBHRect;
    VHdl = T->scBVHdl;
    HHdl = T->scBHHdl;

    size.x = VRect.left;
    size.y = VRect.top;
    CMMove (VHdl, POINT_T (size));

    size.x = HRect.left;
    size.y = HRect.top;
    CMMove (HHdl, POINT_T (size));

    size.x = VRect.right - VRect.left;
    size.y = VRect.bottom - VRect.top;
    CMSize (VHdl, POINT_T (size));

    size.x = HRect.right - HRect.left;
    size.y = HRect.bottom - HRect.top;
    CMSize (HHdl, POINT_T (size));
  }

  /* hideȂ܂܂CUPDATE Cxg show  */
  return;
}


/* File scope functions */
/************************************************
 *	XN[o[̒l̐ݒ		*
 ************************************************/
static Boolean
set_scrollbar_value (TASK * T)
{
  int win_width, win_height;	/* windowRect */
  int dst_width, dst_height;	/* dstRect */
  int width, height;		/* ݂̒l */
  int max_width, max_height;	/* ől */
  int cdef_width, cdef_height;	/* thum ̒ */
  control **scBVHdl, **scBHHdl;
  rect grRect;

  scBVHdl = T->scBVHdl;
  scBHHdl = T->scBHHdl;
  grRect = T->winPtr->wGraph.grRect;

  win_height = grRect.bottom - grRect.top;
  win_width = grRect.right - grRect.left;
  dst_height = T->dRect.bottom;
  dst_width = T->dRect.right;
  max_height = dst_height - win_height;
  max_width = dst_width - win_width;
  cdef_height = dst_height;
  cdef_width = dst_width;
  height = grRect.top;
  width = grRect.left;

  if (win_height >= dst_height)
    {
      if (height)
	max_height = cdef_height = height + win_height;
      else
	max_height = cdef_height = height = 0;
    }
  if (height > max_height)
    height = max_height;
  else if (height < 0)
    height = 0;

  if (win_width >= dst_width)
    {
      if (width)
	max_width = cdef_width = width + win_width;
      else
	max_width = cdef_width = width = 0;
    }
  if (width > max_width)
    width = max_width;
  else if (width < 0)
    width = 0;

  CMMaxSet (scBVHdl, max_height);
  CMMinSet (scBVHdl, 0);
  CMDefDataSet (scBVHdl, cdef_height);
  CMValueSet (scBVHdl, height);

  CMMaxSet (scBHHdl, max_width);
  CMMinSet (scBHHdl, 0);
  CMDefDataSet (scBHHdl, cdef_width);
  CMValueSet (scBHHdl, width);

  return nil;
}

/************************************************
 *	XN[o[̃N^Oݒ	*
 ************************************************/
void
set_scrollbar_rect (TASK * T)
{
  rect grRect, VRect, HRect;

  grRect = T->winPtr->wGraph.grRect;
  VRect = T->scBVRect;
  HRect = T->scBHRect;

  VRect.left = grRect.right - SCB_WIDTH;
  VRect.top = grRect.top;
  VRect.right = grRect.right;
  VRect.bottom = grRect.bottom - SCB_WIDTH;

  HRect.left = grRect.left;
  HRect.top = grRect.bottom - SCB_WIDTH;
  HRect.right = grRect.right - SCB_WIDTH;
  HRect.bottom = grRect.bottom;

  T->scBVRect = VRect;
  T->scBHRect = HRect;
  return;
}
